/*
 *                    BioJava development code
 *
 * This code may be freely distributed and modified under the
 * terms of the GNU Lesser General Public Licence.  This should
 * be distributed with the code.  If you do not have a copy,
 * see:
 *
 *      http://www.gnu.org/copyleft/lesser.html
 *
 * Copyright for this code is held jointly by the individual
 * authors.  These should be listed in @author doc comments.
 *
 * For more information on the BioJava project and its aims,
 * or to join the biojava-l mailing list, visit the home page
 * at:
 *
 *      http://www.biojava.org/
 *
 * Created on 19.03.2004
 * @author Andreas Prlic
 *
 */
package org.synbiowave.biobrick ;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;


// TODO: Auto-generated Javadoc
/**
 * A class to parse the reponse of the BioBrick DAS - entry_points request.
 */
public class BioBrick_DAS_Entry_Points_Handler extends DefaultHandler {

	/** The segments. */
	List<Map<String,String>> segments;
	
	/** The ids. */
	SortedSet<String> ids;
	
	/** The current entry point. */
	Map<String,String> currentEntryPoint;
	
	/**
	 * Instantiates a new bio brick das entry_points handler.
	 */
	public BioBrick_DAS_Entry_Points_Handler(){
		segments=new ArrayList<Map<String,String>>();
		ids=new TreeSet<String>();
		currentEntryPoint=new HashMap<String,String>();}
	
	/* (non-Javadoc)
	 * @see org.xml.sax.helpers.DefaultHandler#startDocument()
	 */
	@Override
	public void startDocument(){
		segments=new ArrayList<Map<String,String>>();
		ids=new TreeSet<String>();}

	/* (non-Javadoc)
	 * @see org.xml.sax.helpers.DefaultHandler#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	@Override
	public void startElement(String uri,String name,String qName,Attributes atts){
		if(qName.equals("SEGMENT")){
			currentEntryPoint=new HashMap<String,String>();
			String id=atts.getValue("id");
			if(!(id==null)){
				currentEntryPoint.put("id",id);
				ids.add(id);}
			String size=atts.getValue("size");
			if(!(size==null)){currentEntryPoint.put("size",size);}
			String start=atts.getValue("start");
			if(!(start==null)){currentEntryPoint.put("start",start);}
			String stop=atts.getValue("stop");
			if(!(stop==null)){currentEntryPoint.put("stop",stop);}
			String orientation=atts.getValue("orientation");
			if(!(orientation==null)){currentEntryPoint.put("orientation",orientation);}
			String subparts=atts.getValue("subparts");
			if(!(subparts==null)){currentEntryPoint.put("subparts",subparts);}}}
	
	/* (non-Javadoc)
	 * @see org.xml.sax.helpers.DefaultHandler#endElement(java.lang.String, java.lang.String, java.lang.String)
	 */
	@Override
	public void endElement(String uri,String name,String qName){
		if(qName.equals("SEGMENT")){segments.add(currentEntryPoint);}}
	
	/**
	 * Gets the segemnts.
	 * 
	 * @return the segemnts
	 */
	public List<Map<String,String>> getSegemnts(){return segments;}
	
	/**
	 * Gets the i ds.
	 * 
	 * @return the i ds
	 */
	public SortedSet<String> getIDs(){return ids;}}