package org.synbiowave.database;

import javax.jdo.JDOHelper;
import javax.jdo.PersistenceManagerFactory;

/** 
 * Static final class for receiving the database persitance manager factory
 * used by the database manager.
 * 
 * @author Jonas
 *
 */
public final class PMF {
    
	/** Static final persitance manager factory. */ 
	private static final PersistenceManagerFactory pmfInstance =
        JDOHelper.getPersistenceManagerFactory("transactions-optional");

    /** Basic contructor for the persitance manager class. */
	private PMF() {}

    /**
     * Returns the static persitance manager factory.
     * 
     * @return PersistenceManagerFactory
     * 
     */
	public static PersistenceManagerFactory get() {return PMF.pmfInstance;}}