package org.synbiowave.menu;

import java.lang.reflect.Type;
import java.util.Map.Entry;

import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;

public class MenuItemDeserializer implements JsonDeserializer<MenuItem>{

	@Override
	public MenuItem deserialize(JsonElement json, Type arg1,JsonDeserializationContext arg2) throws JsonParseException {
		MenuItem mi = new MenuItem();
		JsonObject menuobj = json.getAsJsonObject();
		
		for (Entry<String, JsonElement> entry : menuobj.entrySet()){
			if (entry.getKey().contentEquals("subitem")){
				for (Entry<String, JsonElement> se : entry.getValue().getAsJsonObject().entrySet()){
					mi.appendSubItem(this.deserialize(se.getValue(), arg1, arg2));
				}	
			}
			else {
				mi.setOption(entry.getKey(), entry.getValue().getAsString());
			}
		}
		return mi;
	}
}