package org.synbiowave.menu;

import java.util.ArrayList;
import java.util.UUID;

import org.synbiowave.menu.items.Formular;

import com.google.gson.JsonParseException;


public class MenuItemFactory {

//  ---------------------------------------------------------------------------------
//	Defining variables
//  ---------------------------------------------------------------------------------
	
	/**
	 * A three-digit-string-ID for the current robot
	 */
	private String robotID = null;  
	private int buttonID = 0;	
	
	
//  ---------------------------------------------------------------------------------
//	Constructors
//  ---------------------------------------------------------------------------------
	
	public MenuItemFactory() {
		
	}

	
	
//  ---------------------------------------------------------------------------------
//	Functions
//  ---------------------------------------------------------------------------------
	
	public String generateID() {
		this.buttonID++;
		return Integer.toString(this.buttonID);}
	
	public String generateID(ArrayList<String> blacklist) throws Exception{
		UUID uuid = UUID.randomUUID();
		String myRandom = uuid.toString().replaceAll("-","").substring(0,4);
		//if (! blacklist.contains(myRandom)) myRandom = generateID(blacklist);
		return myRandom;} 
	
	public MenuItem createMenu(String label) throws JsonParseException {
		MenuItem menu = new MenuItem("menu",label,this.robotID + this.generateID());
		return menu;}
	
	public MenuItem createButton(String label) throws JsonParseException {
		MenuItem button = new MenuItem("button",label,this.robotID + this.generateID());
		return button;}
	
	public Formular createForm(String label, String heading) throws JsonParseException {
		Formular form = new Formular(label,heading,this.robotID + this.generateID());
		return form;}
	
	public MenuItem createUpload(String label,String targetURL,String uploadId) throws JsonParseException {
		MenuItem sequenceUpload = new MenuItem("upload",label,this.robotID + this.generateID());
		sequenceUpload.setOption("target", targetURL);
		sequenceUpload.setOption("enctype", "multipart/form-data");
		sequenceUpload.setOption("uploadid",uploadId);
		return sequenceUpload;
	}
	
//  ---------------------------------------------------------------------------------
//	Getters & Setters
//  ---------------------------------------------------------------------------------	
	
	public void setRobotID(String robotID) {
		this.robotID = robotID;
		}
	
	public void unsetRobotID() {
		this.robotID = null;
		}

	public String getRobotID() {
		return robotID;
		}

	}
