package org.synbiowave.menu;

import java.lang.reflect.Type;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;

public class MenuItemSerializer implements JsonSerializer<MenuItem> {

	@Override
	public JsonElement serialize(MenuItem menuItem, Type arg1, JsonSerializationContext arg2) {
		
		JsonObject jMenuItem = new JsonObject();
		
		for (String key : menuItem.getOptions().keySet()){
			if (menuItem.getOption(key).contentEquals("true")) jMenuItem.addProperty(key, true);
			else if (menuItem.getOption(key).contentEquals("false")) jMenuItem.addProperty(key, false);
			else jMenuItem.addProperty(key, menuItem.getOption(key));
		}
		
		/* 
		JsonArray jSubItemList = new JsonArray();
		for (MenuItem subItem : menuItem.getSubItemList()){
			jSubItemList.add(new JsonPrimitive(subItem.getOption("key")));}
		jMenuItem.add("subitem", jSubItemList);
		*/
		
		if (! menuItem.getSubItemList().isEmpty()){
			menuItem.sortSubItems();
			JsonObject jSubItemList = new JsonObject();
			for (MenuItem subItem : menuItem.getSubItemList()){
				jSubItemList.add(subItem.getOption("key"), serialize(subItem, arg1, arg2));}
			jMenuItem.add("subitem", jSubItemList);
		}

		return jMenuItem;}
}