package org.synbiowave.synbiowaverobot;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItemIterator;
import org.apache.commons.fileupload.FileItemStream;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.fileupload.util.Streams;
import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.biojava.ImportExport;
import org.synbiowave.biojava.SequenceUtils;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.menu.MenuItemFactory;
import org.synbiowave.menu.items.Formular;
import org.synbiowave.synbiowaverobot.menucallbacks.ConvertToSequence;
import org.synbiowave.synbiowaverobot.menucallbacks.DebugDisplayDataDocument;
import org.synbiowave.synbiowaverobot.menucallbacks.ImportBiobrick;
import org.synbiowave.synbiowaverobot.menucallbacks.SequenceCircularView;
import org.synbiowave.synbiowaverobot.menucallbacks.SequenceCombine;
import org.synbiowave.synbiowaverobot.menucallbacks.SequenceDownload;
import org.synbiowave.synbiowaverobot.menucallbacks.addRobotCallback;
import org.synbiowave.synbiowaverobot.menucallbacks.formtest;
import org.synbiowave.workspace.Sequence;
import org.waveprotocol.wave.model.id.WaveId;
import org.waveprotocol.wave.model.id.WaveletId;

import com.google.wave.api.Attachment;
import com.google.wave.api.Blip;
import com.google.wave.api.BlipContent;
import com.google.wave.api.BlipContentRefs;
import com.google.wave.api.Context;
import com.google.wave.api.ElementType;
import com.google.wave.api.Gadget;
import com.google.wave.api.JsonRpcResponse;
import com.google.wave.api.Wavelet;
import com.google.wave.api.JsonRpcConstant.ParamsProperty;
import com.google.wave.api.event.DocumentChangedEvent;
import com.google.wave.api.event.Event;
import com.google.wave.api.event.GadgetStateChangedEvent;
import com.google.wave.api.event.WaveletParticipantsChangedEvent;
import com.google.wave.api.event.WaveletSelfAddedEvent;

@SuppressWarnings("serial")
public class SynBioWaveV02Servlet extends AbstractSynBioWaveRobot {
	
	//OAuth informations
	public SynBioWaveV02Servlet(){
		this.setupOAuth("26654640181","L033KXgSPMesjHlYWQrgVPNK","http://gmodules.com/api/rpc");
		this.setupOAuth("26654640181","L033KXgSPMesjHlYWQrgVPNK","http://sandbox.gmodules.com/api/rpc");
		this.setAllowUnsignedRequests(true);}

	//Final Variables
	private final ImportExport ioUtility=new ImportExport();
	
	//Non-final Variables 
	//USE WITH EXTREM CAUTION, AS THEY WILL REGULARY BE SET TO NULL BY APPENGINE
	//MAKE SURE TO REDEFINE THEM BEFORE EVERY USAGE
	public static Map<String,Wavelet> wavelets=new HashMap<String,Wavelet>();

//	Robot profile section ...

	@Override
	public String getRobotName(){return "SynBioWave BETA Robot";}

	@Override
	protected String getRobotAvatarUrl(){return "http://synbiowave.appspot.com/synbiowave_robot.png";}
	
	@Override
	protected String getRobotProfilePageUrl() {return "http://www.SynBioWave.org/";}
	
//	Robot event section ...

	@Capability(contexts = {Context.ALL})
	@Override
	public void onGadgetStateChanged(GadgetStateChangedEvent event){
		Blip blip = event.getBlip();
		Gadget gadget = (Gadget) blip.getElements().get(event.getIndex());
		if(gadget.getUrl().contentEquals("http://www.informatik.uni-freiburg.de/~meinzern/Button.xml"))
		{
			Sequence seq = SequenceUtils.Deserialize(gadget.getProperty("sequence", ""));
			seq.publish(this, event.getWavelet(), true);
		}
		super.onSynBioWaveGadgetChanged(event);} 

	@Override
	public void onWaveletSelfAdded(WaveletSelfAddedEvent event) {
		try{
			//Set up the sequence workspace
			Wavelet workspace=super.newWave(event.getWavelet().getDomain(),event.getWavelet().getParticipants());
			workspace.setTitle("Workspace");
			workspace.getRootBlip().append("Please do not modify the blip content manually.\nOnly choosing the active state of a sequence by using the \"Active:\" checkbox is allowed.");
			List<JsonRpcResponse> responses=this.submit(workspace,this.getWaveRPC(event.getWavelet()));
			for(JsonRpcResponse response:responses){if(response.getData().containsKey(ParamsProperty.WAVELET_ID)){event.getWavelet().getDataDocuments().set("workspace",event.getWavelet().getDomain()+"\n"+response.getData().get(ParamsProperty.WAVE_ID).toString().substring(response.getData().get(ParamsProperty.WAVE_ID).toString().indexOf("!")+1)+"\nconv+root\n"+this.getWaveRPC(event.getWavelet()));}}
			
			//Set Wave-Global-Variables
			event.getWavelet().getDataDocuments().set("SynBioWave", "1");
			event.getWavelet().getDataDocuments().set("ui.gadget.url", this.menuGadgetURL);
			
			//Add the (empty) Menu Gadget
			Gadget menuGadget = new Gadget(this.menuGadgetURL);
			
			Blip root=event.getWavelet().getRootBlip();
			if(root.length()>1){
				Blip swap=root.reply();
				for(BlipContent bc:root.all().values()){swap.append(bc);}
				root.all().delete();}
			root.append(menuGadget);
			root.append("\nPlease notice the new workspace wave in your inbox.\nThis workspace gives you the possibility to review all imported/created sequences and gives you the possibility to set sequences active for the menu functions.\nYou can switch the waves via the inbox window or open both together for easy access.");
			
			//And do all the things all robots do
			super.onSynBioWaveRobotSelfAdded(event);}
		catch(Exception exc){reportError("Initialisation",exc,event);}}
	
	
	public void onWaveletParticipantsChanged(WaveletParticipantsChangedEvent event){
		try {
			if (event.getWavelet().getDataDocuments().contains("workspace")){
				Wavelet workspace= this.getWorkspace(event);
				
				for (String pa : event.getParticipantsAdded()){
					if(!workspace.getParticipants().contains(pa)){workspace.getParticipants().add(pa);}
				}
				//Removing participants does not seem to work at the moment...
				//for (String pa : event.getParticipantsRemoved()){
				//if (workspace.getParticipants().contains(pa)) workspace.getParticipants().remove(pa);	
				//}
				log.info("Adding participants to workspace");
				submit(workspace,this.getWaveRPC(event.getWavelet()));
			}
		} 
		catch (IOException e) { this.reportError("Sorry, there was a connection timeout.\nUnfortunately this is quite normal when Wave has a hight load. We are optimistic that Google will solve that issue soon. Please try again in a moment.", e, event); }
		catch (Exception e) { this.reportError("Sorry, there was an error while updating the workspace's paticipants.\nThe error was logged and will hopefully be fixed soon", e, event); }
	}
	
	
	@Override
	public void onDocumentChanged(DocumentChangedEvent event) {
		if(event.getBlip()!=null&&!event.getBlip().getContent().contains("Sequence download:\nPlease klick on the file icon to start the download.")){
			BlipContentRefs reference=event.getBlip().first(ElementType.ATTACHMENT);
			if(reference!=null&&reference.value()!=null){
				Attachment attachment=(Attachment)reference.value().asElement();
				if(attachment.getData()!=null){
					try{if(this.ioUtility.read(new ByteArrayInputStream(attachment.getData()),this,event)){reference.delete();}}
					catch(IOException e){}}}}}
	
//	Robot menu section 

	@Override
	public void createMenu(MenuItem menu, MenuItemFactory mif, Event event) throws Exception {
		
		MenuItem fileMenu = mif.createMenu("File");
		fileMenu.setOption("sort", "01");
		menu.appendSubItem(fileMenu);
					
			Formular sequenceUpload = mif.createForm("Upload", "Sequence Upload");
			wavelets.put(event.getWavelet().getWaveId().getId(),event.getWavelet());
			sequenceUpload.setOption("sort", "1");
			sequenceUpload.addUpload("Sequence Upload","https://" + this.getRobotAdress(event).replace("@", ".") + "/_wave/robot/jsonrpc",event.getWavelet().getWaveId().getId(),"1");
			fileMenu.appendSubItem(sequenceUpload);
			
			Formular sequenceDownload = mif.createForm("Download","Select output format:");
			sequenceDownload.addRadioButton("Genbank", "format", "1");
			sequenceDownload.addRadioButton("EMBL", "format", "2");
			sequenceDownload.addRadioButton("FASTA", "format", "3");
			sequenceDownload.setOption("order", "2");
			fileMenu.appendSubItem(sequenceDownload);
			this.connectMenuCallBack(sequenceDownload, new SequenceDownload());
			
		MenuItem sequenceMenu = mif.createMenu("Sequence");
		sequenceMenu.setOption("sort", "10");
		menu.appendSubItem(sequenceMenu);
		
			MenuItem ctSequence = mif.createButton("Convert to Sequence");
			ctSequence.setOption("sort", "10");
			this.connectMenuCallBack(ctSequence, new ConvertToSequence());
			sequenceMenu.appendSubItem(ctSequence);
			
			MenuItem circview = mif.createButton("Cicular View");
			circview.setOption("sort", "20");
			this.connectMenuCallBack(circview, new SequenceCircularView());
			sequenceMenu.appendSubItem(circview);
			
			MenuItem combine = mif.createButton("Combine");
			combine.setOption("sort", "30");
			this.connectMenuCallBack(combine, new SequenceCombine());
			sequenceMenu.appendSubItem(combine);
		
		MenuItem databaseMenu = mif.createMenu("Database");
		databaseMenu.setOption("sort", "20");
		menu.appendSubItem(databaseMenu);
			
			Formular importBioBrick = mif.createForm("Import Biobrick", "Import a Biobrick form Parts Registry");
			importBioBrick.setOption("order", "1");
			importBioBrick.addInputfield("Part ID: ", "e.g. BBa_B0030", "");
			databaseMenu.appendSubItem(importBioBrick);
			this.connectMenuCallBack(importBioBrick, new ImportBiobrick());
			
		MenuItem helpMenu = mif.createMenu("Help");
		helpMenu.setOption("sort", "99");
		menu.appendSubItem(helpMenu);
		
			MenuItem debugMenu = mif.createMenu("Debug");
			helpMenu.appendSubItem(debugMenu);
			
				MenuItem displayDataDocument = mif.createButton("Display DataDocument");
				this.connectMenuCallBack(displayDataDocument, new DebugDisplayDataDocument());
				debugMenu.appendSubItem(displayDataDocument);
				
			Formular addons = mif.createForm("Featured Add On Robots", "Select Robot to import:");
			addons.addRadioButton("Alignment Robot", "robots", "1");
			addons.addRadioButton("Translation Robot", "robots", "2");
			addons.addRadioButton("Restriction site finder", "robots", "3");
			addons.addRadioButton("Primer Designer", "robots", "4");
			addons.addRadioButton("BLAST Robot", "robots", "5");
			helpMenu.appendSubItem(addons);
			this.connectMenuCallBack(addons, new addRobotCallback());
				
//				Formular form = mif.createForm("test", "test");
//				form.addRadioButton("1", "A", "01");
//				form.addRadioButton("2", "A", "02");
//				form.addCheckButton("A", "1", "03");
//				form.addCheckButton("B", "1", "04");
//				form.addCheckButton("C", "1", "05");
//				form.addCheckButton("D", "1", "06");
//				helpMenu.appendSubItem(form);
//				this.connectMenuCallBack(form, new formtest());
				
				//MenuItem displayGadgetState = mif.createButton("Display Gadget State");
				//this.connectMenuCallBack(displayGadgetState, new DebugDisplayGadgetState());
				//debugMenu.appendSubItem(displayGadgetState);	
				
				//MenuItem displayMenuJSON = mif.createButton("Display Menu JSON");
				//this.connectMenuCallBack(displayMenuJSON, new DebugDisplayMenuJSON());
				//debugMenu.appendSubItem(displayMenuJSON);	
	}
	
//	Sequence file import/export section ... 
	
	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp){
		try {
//			process sequence file upload
			ImportExport ioUtility=new ImportExport();
			if(!req.getContentType().equalsIgnoreCase("application/json; charset=utf-8")){
				if(req.getContentType().contains("multipart/form-data")){
					ServletFileUpload fileUpload=new ServletFileUpload();
					Wavelet wavelet=null;
					FileItemIterator iterator;
					iterator = fileUpload.getItemIterator(req);
					while(iterator.hasNext()){
						FileItemStream item=iterator.next();
						if(item.isFormField()){
							wavelet=SynBioWaveV02Servlet.wavelets.get(Streams.asString(item.openStream()));}
						else{ioUtility.read(item.openStream(),this,wavelet);}}
					this.submit(wavelet,this.getWaveRPC(wavelet));
					resp.setStatus(HttpURLConnection.HTTP_OK);}}
//			process robot requests
			else{super.doPost(req, resp);}}
		catch(Exception e){resp.setStatus(HttpURLConnection.HTTP_INTERNAL_ERROR);}}
	
	private String getWaveRPC(Wavelet wavelet) {
		if(wavelet.getDomain().contains("sandbox")){return "http://sandbox.gmodules.com/api/rpc";}
		else{return "http://gmodules.com/api/rpc";}}

	public Wavelet getWorkspace(Event event) throws Exception{
		String[] ids = event.getWavelet().getDataDocuments().get("workspace").split("\n");
		String waveid= ids[1];
		WaveId waveId = new WaveId(ids[0], waveid);
		WaveletId waveletId = new WaveletId(ids[0], ids[2]);
		log.info("Getting workspace-wavelet");
		return this.fetchWavelet(waveId, waveletId, ids[3]);
	}
}