package org.synbiowave.synbiowaverobot.menucallbacks;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.biojava.SequenceUtils;
import org.synbiowave.menu.MenuCallBack;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.workspace.Sequence;

import com.google.wave.api.Annotation;
import com.google.wave.api.Blip;
import com.google.wave.api.Range;
import com.google.wave.api.event.Event;

public final class ConvertToSequence extends MenuCallBack {
	
	private boolean proceed=true;
	private AbstractSynBioWaveRobot servlet;
	private Event event;

	public void onButtonClicked(Event event, MenuItem menuItem, AbstractSynBioWaveRobot servlet) {
		try{
			this.proceed=true;
			this.servlet=servlet;
			this.event=event;
			recursiveSelectionAnalysis(event.getWavelet().getRootBlip());}
		catch(Exception exc){event.getBlip().reply().append("Sry Captain, seems to be a problem in the convertion maschine.\nPlease try again.");}}	

	private void recursiveSelectionAnalysis(Blip blip){
		for(Annotation a:blip.getAnnotations()){
			if(a.getName().contains("user/r/")){
				Range range=a.getRange();
				blip.range(range.getStart(),range.getEnd()).clearAnnotation(a.getName());
				Sequence sequence=new Sequence(this.event.getModifiedBy(),blip.getContent().substring(range.getStart(),range.getEnd()).replaceAll("[\\n\\r]",""));
				sequence.setAuthor(this.event.getModifiedBy());
				sequence.addAnnotation("wave creation",1,sequence.getSequence().length());
				sequence.publish(this.servlet,event.getWavelet(),true);
				blip.range(range.getStart(),range.getEnd()).replace(sequence.getSequence());
				SequenceUtils.addScaling(blip,new Range(range.getStart(),range.getStart()+sequence.getSequence().length()));
				SequenceUtils.addSequenceColors(blip,SequenceUtils.determineType(sequence.getSequence()));
				this.proceed=false;
				break;}}
		if(proceed){for(Blip childBlip:blip.getChildBlips()){recursiveSelectionAnalysis(childBlip);}}}}