package org.synbiowave.synbiowaverobot.menucallbacks;

import java.io.IOException;
import java.util.ArrayList;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.biobrick.BioBrick;
import org.synbiowave.biobrick.PartsRegistryXmlParser;
import org.synbiowave.biojava.SequenceUtils;
import org.synbiowave.menu.MenuCallBack;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.menu.items.Formular;
import org.synbiowave.workspace.Sequence;

import com.google.wave.api.Blip;
import com.google.wave.api.Gadget;
import com.google.wave.api.event.Event;

public class ImportBiobrick extends MenuCallBack {
	@Override
	public void onFormSubmit(Event event, Formular menuItem, AbstractSynBioWaveRobot servlet)
	{
		ArrayList<MenuItem> part = menuItem.getPureForm().getSubItemsOfType("textfield");
		String PartID = part.get(0).getValue();
		
		BioBrick BB = new BioBrick();
		try {
			BB = PartsRegistryXmlParser.parseSequenceFromFile(PartID);
		} catch (IOException e) {
			event.getBlip().append("Sorry this Part doesnt exist!");
			return;
		}
		ArrayList<Sequence> list = new ArrayList<Sequence>();
		list.add(BB.toSequence());
		
		Blip output = event.getBlip().reply();
		SequenceUtils.showGadgetView(output, list);
		
		output.append("\nThis Sequence was imported from Parts Registry. \n" +
				"Name :" + BB.getName() +
				"\nID :" + Integer.toString(BB.getId()) +
				"\nAuthor: " + BB.getAuthor() +
				"\nDescription: " + BB.getDescr() +
				"\nURL: " + BB.getUrl() + "\n");
		
		Gadget button = new Gadget("http://www.informatik.uni-freiburg.de/~meinzern/Button.xml");
		button.setProperty("label", "Store in Workspace");
		button.setProperty("sequence", SequenceUtils.Serialize(BB.toSequence()));
		output.append(button);
		
		
		
	}

}
