package org.synbiowave.synbiowaverobot.menucallbacks;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.menu.MenuCallBack;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.workspace.Sequence;
import org.synbiowave.workspace.Workspace;

import com.google.wave.api.Annotation;
import com.google.wave.api.Blip;
import com.google.wave.api.Gadget;
import com.google.wave.api.event.Event;

public final class SequenceCircularView extends MenuCallBack {

	public void onButtonClicked(Event event, MenuItem menuItem, AbstractSynBioWaveRobot servlet) {
		try{
			List<Sequence> actives=Workspace.getActiveSequences(servlet,event.getWavelet());
			if(!actives.isEmpty()){
				Sequence sequence=actives.get(0);
				String sequences="{ \"entries\" : [ { \"name\" : \""+sequence.getName()+"\" , \"sequence\" : \""+sequence.getSequence()+"\" } , ";
				List<String> layers=new ArrayList<String>();
				Blip reply=event.getWavelet().reply("\n");
				List<int[]> spacing_layers=new ArrayList<int[]>();
				List<Annotation> annotations=sequence.getAnnotations();
				while(!annotations.isEmpty()){
					int length=0;
					int index=0;
					for(int i=0;i<annotations.size();i++){
						Annotation annotation=annotations.get(i);
						if(annotation.getRange().getEnd()-annotation.getRange().getStart()>length){
							length=annotation.getRange().getEnd()-annotation.getRange().getStart();
							index=i;}}
					Annotation annotation=annotations.get(index);
					int layer_index=-1;
					for(int i=0;i<spacing_layers.size();i++){
						int[] layer_spacing=spacing_layers.get(i);
						boolean space=true;
						for(int position=annotation.getRange().getStart();position<=annotation.getRange().getEnd();position++){
							layer_spacing[position]++;
							if(layer_spacing[position]>1){
								space=false;
								break;}}
						if(space){
							layer_index=i;
							spacing_layers.set(layer_index,layer_spacing);
							break;}}
					if(layer_index>-1){
						if(layers.get(layer_index).endsWith("} ")){layers.set(layer_index,layers.get(layer_index)+", ");}
						layers.set(layer_index,layers.get(layer_index)+"{ \"name\" : \""+annotation.getValue()+"\" , \"start\" : \""+annotation.getRange().getStart()+"\" , \"end\" : \""+annotation.getRange().getEnd()+"\" } ");}
					else{
						int[] layer_spacing=new int[sequence.getSequence().length()+1];
						for(int position=annotation.getRange().getStart();position<=annotation.getRange().getEnd();position++){layer_spacing[position]=1;}
						spacing_layers.add(layer_spacing);
						layers.add("{ \""+layers.size()+"\" : [ "+"{ \"name\" : \""+annotation.getValue()+"\" , \"start\" : \""+annotation.getRange().getStart()+"\" , \"end\" : \""+annotation.getRange().getEnd()+"\" } ");}
					annotations.remove(index);}
				for(Iterator<String> iterator=layers.iterator();iterator.hasNext();){
					sequences+=iterator.next()+"] } ";
					if(iterator.hasNext()){sequences+=", ";}}
				sequences+="] }";
				Gadget sbw_panel=new Gadget("http://synbiowave-panel.appspot.com/richview/org.synbiowave.sequence.client.RichSequenceEditor.gadget.xml");
				sbw_panel.setProperty("sequences",sequences);
				reply.append(sequences);
				reply.append(sbw_panel);}}
		catch(Exception e){event.getWavelet().reply("\nRichSequenceEditor Creation Error:"+e.toString());}}}