package org.synbiowave.synbiowaverobot.menucallbacks;

import java.util.List;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.biojava.SequenceUtils;
import org.synbiowave.menu.MenuCallBack;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.workspace.Sequence;
import org.synbiowave.workspace.Workspace;

import com.google.wave.api.Annotation;
import com.google.wave.api.event.Event;

public final class SequenceCombine extends MenuCallBack {

	public void onButtonClicked(Event event, MenuItem menuItem, AbstractSynBioWaveRobot servlet) {
		List<Sequence> sequences=Workspace.getActiveSequences(servlet,event.getWavelet());
		if(sequences!=null&&sequences.size()>1){
			Sequence combined=new Sequence();
			int index=0;
			for(Sequence part:sequences){
				combined.setSequence(combined.getSequence()+part.getSequence());
				for(Annotation feature:part.getAnnotations()){combined.addAnnotation(feature.getValue(),feature.getRange().getStart()+index,feature.getRange().getEnd()+index);}
				combined.addAnnotation(part.getName(),1+index,part.getSequence().length()+index);
				index=combined.getSequence().length();}
			combined.setName("combined sequence");
			combined.setAuthor(event.getModifiedBy());
			combined.setType(SequenceUtils.determineType(combined.getSequence()));
			combined.publish(servlet,event.getWavelet(),true);
			combined.showGadgetView(event.getWavelet().reply("\n"));}
		else{event.getWavelet().reply("\nUm Captain?!?\n There are no combinations to do.\nCheck the workspace and set some sequences active.");}}}


