package org.synbiowave.synbiowaverobot.menucallbacks;

import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import java.util.List;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.biojava.ImportExport;
import org.synbiowave.menu.MenuCallBack;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.menu.items.Formular;
import org.synbiowave.workspace.Sequence;
import org.synbiowave.workspace.Workspace;

import com.google.wave.api.Attachment;
import com.google.wave.api.event.Event;

public final class SequenceDownload extends MenuCallBack {

	public void onButtonClicked(Event event, MenuItem menuItem, AbstractSynBioWaveRobot servlet) {
		try{
			List<Sequence> sequences=Workspace.getActiveSequences(servlet,event.getWavelet());
			if(!sequences.isEmpty()){
				ByteArrayOutputStream out=new ByteArrayOutputStream(); 
				ImportExport ioUtility=new ImportExport();
				ioUtility.write(out,sequences,"genbank");
				Attachment attachment=new Attachment("sequence.gb",out.toByteArray());
				event.getWavelet().reply("\nSequence download:\nPlease klick on the file icon to start the download.\n").append(attachment);}}
		catch(Exception exc){event.getWavelet().reply("\nSorry Captain, but we are experiencing some slight turbulence while preparing the sequences for the download.");}}

	@Override
	public void onFormSubmit(Event event, Formular menuItem, AbstractSynBioWaveRobot servlet)
	{
		String format = "";
		String ending = "";
		// Evaluate Form
		ArrayList<MenuItem> radios = menuItem.getPureForm().getSubItemsOfType("radio");
		if(radios.get(0).getOption("value").contentEquals("true"))
		{
			format = "genbank";
			ending = "gb";
		}
		if(radios.get(1).getOption("value").contentEquals("true"))
		{
			format = "EMBL";
			ending = "embl";
		}
		if(radios.get(2).getOption("value").contentEquals("true"))
		{
			format = "FASTA";
			ending = "fa";
		}
		
		try{
			List<Sequence> sequences=Workspace.getActiveSequences(servlet,event.getWavelet());
			if(!sequences.isEmpty()){
				ByteArrayOutputStream out=new ByteArrayOutputStream(); 
				ImportExport ioUtility=new ImportExport();
				ioUtility.write(out,sequences,format);
				Attachment attachment=new Attachment("sequence_"+format+"."+ending,out.toByteArray());
				event.getWavelet().reply("\nSequence download:\nPlease klick on the file icon to start the download.\n").append(attachment);}}
		catch(Exception exc){event.getWavelet().reply("\nSorry Captain, but we are experiencing some slight turbulence while preparing the sequences for the download.");}
	}
}