/*
 *                    BioJava development code
 *
 * This code may be freely distributed and modified under the
 * terms of the GNU Lesser General Public Licence.  This should
 * be distributed with the code.  If you do not have a copy,
 * see:
 *
 *      http://www.gnu.org/copyleft/lesser.html
 *
 * Copyright for this code is held jointly by the individual
 * authors.  These should be listed in @author doc comments.
 *
 * For more information on the BioJava project and its aims,
 * or to join the biojava-l mailing list, visit the home page
 * at:
 *
 *      http://www.biojava.org/
 *
 * Created on 19.03.2004
 * @author Andreas Prlic
 *
 */
package org.synbiowave.biobrick;


import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.Attributes;

/**
 * A class to parse the XML response of a DAS-DNA request.
 * 
 * @author Jonas
 */
public class BioBrick_DAS_DNA_Handler extends DefaultHandler {

	/** The sequence. */
	String sequence ;
	
	/** The length. */
	int length ;
	
	/** The dna_flag. */
	boolean dna_flag; 
	
	/**
	 * Instantiates a new bio brick das dna handler.
	 */
	public BioBrick_DAS_DNA_Handler() {
		super();
		sequence="";
		length=0;
		dna_flag=false;}

	/* (non-Javadoc)
	 * @see org.xml.sax.helpers.DefaultHandler#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	@Override
	public void startElement (String uri,String name,String qName,Attributes atts){
	    if(qName.equals("DNA")){
			String lenstr=atts.getValue("length");
			this.length=Integer.parseInt(lenstr);
			this.dna_flag=true;}}
	
	/* (non-Javadoc)
	 * @see org.xml.sax.helpers.DefaultHandler#characters(char[], int, int)
	 */
	@Override
	public void characters (char ch[],int start,int length){
	    if(this.dna_flag){
	    	for(int i=start;i<start+length;i++){
				 switch(ch[i]){
				 	case '\\':
				 		break;
				 	case '"':
				 		break;
				 	case '\n':
				 		break;
				 	case '\r':
				 		break;
				 	case '\t':
				 		break;
				 	case ' ':
				 		break;
				 	default:
				 		this.sequence=this.sequence+ch[i];
				 		break;}}}}
	
	/**
	 * Gets the sequence.
	 * 
	 * @return String sequence
	 */
	public String getSequence() {
		if(this.length!=this.sequence.length()){System.err.println("Sequence does not match specified length!");}
		return sequence;}}